package org.rcisoft.sys.visit.service;

import com.baomidou.mybatisplus.core.metadata.IPage;
import org.rcisoft.sys.visit.entity.VisitInfoMation;
import org.rcisoft.core.model.CyPersistModel;
import org.rcisoft.core.model.CyPageInfo;

import javax.servlet.http.HttpServletRequest;
import java.util.List;

/**
 * Created by cy on 2022年11月16日 下午2:40:21.
 */
public interface VisitInfomationService {

    /**
    * 保存 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel persist(VisitInfoMation visitInfomation);

    /**
    * 删除 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel remove(VisitInfoMation visitInfomation);
    /**
    * 逻辑删除 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel removeLogical(VisitInfoMation visitInfomation);
    /**
    * 修改 邀访信息
    * @param visitInfomation
    * @return
    */
    CyPersistModel merge(VisitInfoMation visitInfomation);

    /**
    * 根据id查询 邀访信息
    * @param id
    * @return
    */
    VisitInfoMation findById(int id);

    /**
    * 分页查询 邀访信息
    * @param visitInfomation
    * @return
    */
    IPage<VisitInfoMation> findAllByPagination(CyPageInfo<VisitInfoMation> paginationUtility,
                                               VisitInfoMation visitInfomation);


    /**
    * 查询list 邀访信息
    * @param visitInfomation
    * @return
    */
    List<VisitInfoMation> findAll(VisitInfoMation visitInfomation);


    /**
    * 导出邀访信息
    * @return
    */
    List<VisitInfoMation> export(VisitInfoMation visitInfomation);

    /**
     * 查询当前登录人最新首要记录
     * @return
     */
    VisitInfoMation lastDetail(HttpServletRequest request);
}
