package org.rcisoft.sys.sysuser.dao;

import org.apache.ibatis.annotations.Mapper;
import org.rcisoft.core.mapper.CyBaseMapper;
import org.rcisoft.sys.sysuser.entity.SysUser;
import org.rcisoft.core.model.CyPageInfo;
import org.apache.ibatis.annotations.Param;
import com.baomidou.mybatisplus.core.metadata.IPage;

import java.util.List;

/**
 * Created with cy on 2022年11月16日 下午3:19:19.
 */
@Mapper
public interface SysUserRepositorys extends CyBaseMapper<SysUser> {


    List<SysUser> querySysUsers(@Param("entity") SysUser sysUser);

    //新增
    public int addSysUser(@Param("entity")SysUser sysUser);

    //逻辑删除
    public int delSysUser(Long business_id);

    //更新
    public int updateSysUser(@Param("entity") SysUser sysUser);

    //单个查询
    SysUser querySysUsersById(Long business_id);
    /**
     * 分页查询 sysUser
     */
    IPage<SysUser> querySysUsersPaged(CyPageInfo cyPageInfo, @Param("entity") SysUser sysUser);




}

