package org.rcisoft.sys.visit.entity;

import cn.afterturn.easypoi.excel.annotation.Excel;
import com.baomidou.mybatisplus.annotation.TableName;
import lombok.*;

import org.rcisoft.core.entity.CyIdIncreEntity;

import java.math.BigInteger;

/**
* Created with cy on 2022年11月16日 下午4:30:18.
*/
@Data
@TableName("visit_user")
public class VisitUser  extends CyIdIncreEntity<VisitUser> {


     /**
     * @desc 访问记录id
     * @column visit_id
     * @default
     */
     @Excel(name = "访问记录id", orderNum = "0", width = 20)
     private Integer visitId;

     /**
     * @desc 访客姓名
     * @column user_name
     * @default
     */
     @Excel(name = "访客姓名", orderNum = "1", width = 20)
     private String userName;

     /**
     * @desc 访客手机号
     * @column visit_phone
     * @default
     */
     @Excel(name = "访客手机号", orderNum = "2", width = 20)
     private String visitPhone;


}

